const { getUser, getCoins, commas, saveGame } = require('./utils');
const quackStore = require('./quackstore');

const possiblePrestige = coins => {
  let p = 0
  while (tpcRec(p + 1) <= coins) {
    p += 1
  }
  return p
}

const totalCostForPrestige = prestigeLevel => {
  let cost = 0
  while (prestigeLevel) {
    cost += 1_000_000_000_000 * Math.pow(prestigeLevel, 3)
    prestigeLevel -= 1
  }
  return cost
}

const tpcRecMemo = []
const tpcRec = prestigeLevel => {
  if (prestigeLevel === 0) {
    return 0
  }
  return (tpcRecMemo[prestigeLevel]) || (tpcRecMemo[prestigeLevel] = 1_000_000_000_000 * Math.pow(prestigeLevel, 3) + tpcRec(prestigeLevel - 1))
}

// TODO
const prestigeRoute = async ({ event, say, words }) => {
      const user = getUser(event.user)
      getCoins(event.user)
      const possible = possiblePrestige(user.coinsAllTime)
      const current = user.prestige ??= 0
      if (words[1] === 'me') {
        await say(
            'This will permanently remove all of your items, upgrades, and coins!\n\n' +
            'Say \'!!prestige me\' to confirm.'
        )
      } else {
        await say(
            `Current Prestige: ${commas(current)}\n\n` +
            `Quacks gained if you prestige now: ${commas(possible - current)}\n\n` +
            `HVAC until next quack: ${commas(Math.round(tpcRec(possible + 1) - user.coinsAllTime))}\n\n` +
            'Say \'!prestige me\' to start the prestige process.'
        )
      }
    }//, true, adminOnly)

// TODO
const prestigeConfirmRoute = async ({ event, say, words }) => {
      const user = getUser(event.user)
      getCoins(event.user)
      const possible = possiblePrestige(user.coinsAllTime)
      const current = user.prestige
      if (possible <= current) {
        await say('You don\'t have enough HVAC to prestige right now!')
        return
      }
      if (event?.text !== '!!prestige me') {
        await say('Say exactly \'!!prestige me\' to confirm')
        return
      }
      console.log('possible', possible)
      console.log('user.prestige', user.prestige)
      user.quacks ??= 0
      user.quacks += (possible - user.prestige)
      console.log('user.quacks', user.quacks)
      user.prestige = possible
      user.coins = 0
      user.items = {}
      user.upgrades = {}
      saveGame()
      await say('You prestiged! Check out !quackstore to see what you can buy!')
    }

const quackStoreListing = ([name, upgrade]) =>
    `:${upgrade.emoji}: *${name}* - Costs *${upgrade.cost} Quack.*\n\n_${upgrade.description}_`

const allUserQuackUpgrades = user =>
    Object.entries(user.quackUpgrades || {})
        .map(([type, upgrades]) => upgrades)

const hasPreReqs = user => ([name, upgrade]) => {
  if (!upgrade.preReqs) {
    return true
  }
  const allUserUpgrades = allUserQuackUpgrades(user)
  console.log(allUserUpgrades)
  return upgrade.preReqs.every(preReq => allUserUpgrades.includes(preReq))
}

const quackStoreText = user =>
    Object.entries(quackStore)
        .filter(hasPreReqs(user))
        .map(quackStoreListing)
        .join('\n\n')

const quackStoreRoute = async ({ event, say, words }) => {
  const user = getUser(event.user)
  user.quackUpgrades ??= {}
  const quacks = user.quacks ??= 0
  if (!words[1]) {
    await say(quackStoreText(user))
    return
  }
  const quackItem = quackStore[words[1]]
  if (!quackItem) {
    await say(`'${words[1]}' is not available in the quack store!`)
    return
  }
  if (quackItem.cost > quacks) {
    await say(`${words[1]} costs ${quackItem.cost} Quacks, but you only have ${quacks}!`)
    return
  }
  user.quackUpgrades[quackItem.type] ??= []
  user.quackUpgrades[quackItem.type].push(words[1])
  saveGame()
}

module.exports = {
  quackStoreRoute,
  prestigeRoute,
  prestigeConfirmRoute
}
