const basic = ({ type, description, count, cost }) => ({
  type,
  description,
  condition: user => user.items[type] >= count,
  cost,
  effect: itemCps => itemCps * 2
})

module.exports = {
  doubleClick: basic({
    type: 'mouse',
    description: 'Doubles the power of mice',
    count: 1,
    cost: 1_000,
  }),
  stinkierCheese: basic({
    type: 'mouse',
    description: 'Mice are doubly motivated to hunt down HVAC Coins',
    count:  10,
    cost: 21_000,
  }),
  biggerTeeth: basic({
    type: 'mouse',
    description: 'Mice can intimidate twice as much HVAC out of their victims.',
    count:  25,
    cost: 50_000,
  }),

  fasterComputers: basic({
    type: 'accountant',
    description: 'Accountants can ~steal~ optimize twice as much HVAC!',
    count: 1,
    cost: 11_000,
  }),
  lackOfMorality: basic({
    type: 'accountant',
    description: 'Accountants are taking a hint from nearby CEOs.',
    count:  10,
    cost: 200_000,
  }),
  widerBrains: basic({
    type: 'accountant',
    description: 'For accountant do double of thinking.',
    count:  25,
    cost: 550_000,
  }),

  biggerBlowhole: basic({
    type: 'whale',
    description: 'With all that extra air, whales have double power!',
    count: 1,
    cost: 120_000,
  }),
  sassyWhales: basic({
    type: 'whale',
    description: 'These are the kind of whales that know how to get twice as much done',
    count:  10,
    cost: 3_000_000,
  }),
  thinnerWater: basic({
    type: 'whale',
    description: 'Whales can move twice as quickly through this physics-defying liquid',
    count:  25,
    cost: 6_000_000,
  }),

  greasyTracks: basic({
    type: 'train',
    description: 'Lets trains deliver HVAC twice as efficiently',
    count: 1,
    cost: 1_300_000,
  }),
  rocketThrusters: basic({
    type: 'train',
    description: 'That\'ll put some quack on your track',
    count:  10,
    cost: 22_000_000,
  }),
  loudConductors: basic({
    type: 'train',
    description: 'Conductors can onboard twice as much HVAC',
    count:  25,
    cost: 65_000_000,
  }),

  gasolineFire: basic({
    type: 'fire',
    description: 'Extremely good for breathing in.',
    count: 1,
    cost: 14_000_000,
  }),
  extremelyDryFuel: basic({
    type: 'fire',
    description: 'Use the ignite command for a secret achievement.',
    count: 10,
    cost: 163_000_000,
  }),
  cavemanFire: basic({
    type: 'fire',
    description: 'They just don\'t make \'em like they used to.',
    count:  25,
    cost: 700_000_000,
  }),

  spoonerang: basic({
    type: 'boomerang',
    description: 'Scoops up HVAC mid-flight',
    count: 1,
    cost: 200_000_000,
  }),
  boomerAng: basic({
    type: 'boomerang',
    description: 'It\'s... old.',
    count: 10,
    cost: 1_200_000_000,
  }),
  doubleRang: basic({
    type: 'boomerang',
    description: 'You throw one, but somehow catch two',
    count:  25,
    cost: 10_000_000_000,
  }),

  lunarPower: basic({
    type: 'moon',
    description: 'Out with the sol, in with the lun!',
    count: 1,
    cost: 3_300_000_000,
  }),
  womanOnTheMoon: basic({
    type: 'moon',
    description: 'There\'s no reason for it not to be a woman!',
    count: 10,
    cost: 39_700_000_000,
  }),
  doubleCraters: basic({
    type: 'moon',
    description: 'Making every side look like the dark side.',
    count:  25,
    cost: 165_000_000_000,
  }),

  glassButterfly: basic({
    type: 'butterfly',
    description: 'Not your grandma\'s universe manipulation.',
    count: 1,
    cost: 51_000_000_000,
  }),
  monarchMigration: basic({
    type: 'butterfly',
    description: 'This upgrade brought to you by milkweed.',
    count: 10,
    cost: 870_000_000_000,
  }),
  quadWing: basic({
    type: 'butterfly',
    description: 'Sounds a lot like a trillion bees buzzing inside your head.',
    count:  25,
    cost: 2_550_000_000_000,
  }),

  silverMirror: basic({
    type: 'mirror',
    description: 'Excellent for stabbing vampires.',
    count: 1,
    cost: 750_000_000_000,
  }),
  window: basic({
    type: 'mirror',
    description: 'Only through looking around you can you acquire the self reflection necessary to control the thermostat.',
    count:  25,
    cost: 37_500_000_000_000,
  }),

  fzero: basic({
    type: 'quade',
    description: 'Brings out his competitive spirit.',
    count: 1,
    cost: 10_000_000_000_000,
  }),
  adam: basic({
    type: 'quade',
    description: 'He could probably reach the thermostat if he wanted.',
    count:  25,
    cost: 500_000_000_000_000,
  }),

  latestNode: basic({
    type: 'hvacker',
    description: 'The old one has terrible ergonomics, tsk tsk.',
    count:  1,
    cost: 140_000_000_000_000,
  }),
  gitCommits: basic({
    type: 'hvacker',
    description: 'The heads of multiple people in a company are better than, for example, merely one head.',
    count:  25,
    cost: 7_000_000_000_000_000,
  }),

  homage: {
    type: 'general',
    description: 'The power of original ideas increases your overall CPS by 10%',
    condition: user => Object.entries(user.items).reduce((total, [, countOwned]) => countOwned + total, 0) >= 200,
    emoji: 'cookie',
    cost: 10_000_000_000,
    effect: (itemCps, user) => Math.ceil(itemCps * 1.1)
  },
  iLoveHvac: {
    type: 'general',
    description: 'The power of love increases your overall CPS by 10%',
    condition: user => Object.entries(user.items).reduce((total, [, countOwned]) => countOwned + total, 0) >= 400,
    emoji: 'heart',
    cost: 100_000_000_000_000,
    effect: (itemCps, user) => Math.ceil(itemCps * 1.1)
  }

  // moreUpgrades: {
  //   type: 'general',
  //   description: 'Adds additional upgrades',
  //   condition: user => Object.entries(user.items).reduce((total, [, countOwned]) => countOwned + total, 0) >= 400,
  //   emoji: 'cookie',
  //   cost: 10_000_000_000_000,
  //   effect: nothing
  // },
}

